startup
{
	vars.timerModel = new TimerModel { CurrentState = timer };

	vars.timerPaused = false;
	vars.timerHidden = false;

	vars.backShown = false;
	vars.backPrior = false;

	vars.skipShown = false;
	vars.skipPrior = false;
	vars.skipFalling = false;
	vars.skipWasPrimed = false;
	
	vars.restartShown = false;
	vars.restartPrior = false;
	vars.restartFalling = false;
	vars.restartWasPrimed = false;
}

update
{
	vars.timerPaused = features["TimerPerf"].current > 15.0 || features["TimerFidelity"].current > 15.0;
	vars.timerHidden = features["BlackSpace"].current > 15.0 && features["BlackSpaceAngelKnives"].current > 15.0;

	vars.backShown = features["BackButtonPerf"].current > 15.0 || features["BackButtonFidelity"].current > 15.0;
	vars.backPrior = features["BackButtonPerf"].old > 15.0 || features["BackButtonFidelity"].old > 15.0;

	vars.skipShown = features["SkipPerf"].current > 15.0 || features["SkipFidelity"].current > 15.0;
	vars.skipPrior = features["SkipPerf"].old > 15.0 || features["SkipFidelity"].old > 15.0;

	vars.restartShown = features["RestartPerf"].current > 15.0 || features["RestartFidelity"].current > 15.0;
	vars.restartPrior =	features["RestartPerf"].old > 15.0 || features["RestartFidelity"].old > 15.0;

	// This logic uses the concept of falling/rising edges to get the exact trigger when a skip cutscene was selected.
	if (!vars.skipFalling && vars.skipWasPrimed) {
		if (vars.backPrior && !vars.backShown && vars.timerHidden) {
			vars.skipFalling = true;
		}
	} else {
		vars.skipFalling = false;
	}

	// We only get ready to apply the above logic when the back button is shown and "SkipCinematic" is present.
	vars.skipWasPrimed = vars.backShown && vars.skipShown;

	// Similar to the logic above, but for detecting the instant RE/RC was selected.
	if (!vars.restartFalling && vars.restartWasPrimed) {
		if (vars.backPrior && !vars.backShown && vars.timerHidden) {
			vars.restartFalling = true;
		}
	} else {
		vars.restartFalling = false;
	}

	// We only get ready to apply the above logic when the back button is shown and "Restart" is present.
	vars.restartWasPrimed = vars.backShown && vars.restartShown;

	// Each RE/RC/SC should add 20ms to the timer.
	if (vars.restartFalling || vars.skipFalling) {
		vars.timerModel.CurrentState.SetGameTime(vars.timerModel.CurrentState.CurrentTime.GameTime + new TimeSpan( 0, 0, 0, 0, 20));
	}
}

isLoading
{
	return vars.timerPaused || vars.backShown || vars.timerHidden;
}
